﻿using Syncfusion.UI.Xaml.Controls.Input;
using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Custom_editor
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        internal Appointment SelectedAppointment;
        internal SfSchedule schedule;
        public MainPage()
        {
            this.InitializeComponent();
            schedule = this.Schedule;
            Appointment newappointment = new Appointment();
            newappointment.StartTime = DateTime.Now.Date.AddHours(9);
            newappointment.EndTime = DateTime.Now.Date.AddHours(10);
            newappointment.FirstName = "John";
            newappointment.LastName = "R";
            newappointment.Subject = "Meeting";
            newappointment.Location = "Office";
            newappointment.Notes = "Need to collect Project Requirement";
            schedule.Appointments.Add(newappointment);
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void SfSchedule_AppointmentEditorOpening_1(object sender, Syncfusion.UI.Xaml.Schedule.AppointmentEditorOpeningEventArgs e)
        {            
            if (e.Action == EditorAction.Add)
            {
                //For avoid showing of default editor
                e.Cancel = true;

                //new appointment is created and setting the created appointment as datacontext to the custom control. After that control visiblity is set to Visible
                Appointment newappointment = new Appointment();
                newappointment.StartTime = e.StartTime;
                newappointment.EndTime = e.StartTime.AddMinutes(60);
                AddAppointment(newappointment);
            }
            else if (e.Action == EditorAction.Edit)
            {
                //For avoid showing of default editor
                e.Cancel = true;

                //Setting the selected appointment as datacontext to the custom control. After that control visiblity is set to Visible
                EditAppointment((Appointment)e.Appointment);
            }
        }

        //When adding new appointment in schedule
        private void AddAppointment(Appointment NewAppointment)
        {
            customeEditor.DataContext = null;
            customeEditor.DataContext = NewAppointment;
            customeEditor.Visibility = Visibility.Visible;
            SelectedAppointment = null;           
            customeEditor.Delete.Visibility = Visibility.Collapsed;
            customeEditor.Subject.Text = string.Empty;
            customeEditor.Notes.Text = string.Empty;
            customeEditor.Location.Text = string.Empty;
            customeEditor.FirstName.Text = string.Empty;
            customeEditor.LastName.Text = string.Empty;
        }

        //When editing the existing appointments in schedule
        private void EditAppointment(Appointment ExistingAppointment)
        {
            customeEditor.DataContext = null;
            customeEditor.DataContext = ExistingAppointment;

            customeEditor.Visibility = Visibility.Visible;
            SelectedAppointment = ExistingAppointment ;
            customeEditor.Delete.Visibility = Visibility.Visible;           
            customeEditor.Subject.Text = SelectedAppointment.Subject;
            customeEditor.Notes.Text = SelectedAppointment.Notes;
            customeEditor.Location.Text = SelectedAppointment.Location;
            customeEditor.FirstName.Text = SelectedAppointment.FirstName;
            customeEditor.LastName.Text = SelectedAppointment.LastName;
        }
    }

    #region NewCustomEditor Class

    public class NewCustomEditor : Control
    {
        #region Constructor
        public NewCustomEditor()
        {
            this.DefaultStyleKey = typeof(NewCustomEditor);
            this.UpdateLayout();
        }
        #endregion

        #region Private Members
               
        public SfTextBoxExt Subject;
        public SfTextBoxExt Notes;
        public SfTextBoxExt Location;
        public SfTextBoxExt FirstName;
        public SfTextBoxExt LastName;
        public Button Close;
        public Button Save;      
        public MainPage editorPage;              
        public Button Delete;
       


        #endregion

        #region Override Methods
        protected override void OnApplyTemplate()
        {
            editorPage = (MainPage)(this.Parent as Grid).Parent;           
            Subject = GetTemplateChild("sub") as SfTextBoxExt;
            Notes = GetTemplateChild("notes") as SfTextBoxExt;
            Location = GetTemplateChild("where") as SfTextBoxExt;
            FirstName = GetTemplateChild("firstname") as SfTextBoxExt;
            LastName = GetTemplateChild("lastname") as SfTextBoxExt;
            Close = GetTemplateChild("close") as Button;
            Save = GetTemplateChild("save") as Button;           
            Delete = GetTemplateChild("delete") as Button;           
            this.Visibility = Visibility.Collapsed;           
            Close.Click += Close_Click;
            Save.Click += Save_Click;
            Delete.Click += Delete_Click;           
            this.Visibility = Visibility.Collapsed;
            base.OnApplyTemplate();
        }
        #endregion

        #region Events

        void Delete_Click(object sender, RoutedEventArgs e)
        {
            Visibility = Visibility.Collapsed;
            if (editorPage.SelectedAppointment != null)
            {
                editorPage.schedule.Appointments.Remove(editorPage.SelectedAppointment);
            }
        }

        void Save_Click(object sender, RoutedEventArgs e)
        {
            Visibility = Visibility.Collapsed;
            Appointment app;
            if (editorPage.SelectedAppointment == null)
            {
                app = new Appointment();
                app.StartTime = (this.DataContext as Appointment).StartTime;
                app.EndTime = (this.DataContext as Appointment).EndTime;
                app.AppointmentBackground = new SolidColorBrush(Color.FromArgb(0xFF, 0xA2, 0xC1, 0x39));
            }
            else
            {
                app = editorPage.SelectedAppointment;              
                app.AppointmentBackground = new SolidColorBrush(Color.FromArgb(0xFF, 0xA2, 0xC1, 0x39));
            }
            app.Subject = Subject.Text;
            app.Notes = Notes.Text;
            app.Location = Location.Text;
            app.FirstName = FirstName.Text;
            app.LastName = LastName.Text;
            if (editorPage.SelectedAppointment == null)
            {
                editorPage.schedule.Appointments.Add(app);
            }
        }

        void Close_Click(object sender, RoutedEventArgs e)
        {
            Visibility = Visibility.Collapsed;
        }

        #endregion
    }

    #endregion

    #region Appointment Class

    public class Appointment : ScheduleAppointment
    {
        #region Public Properties       

        public string FirstName { get; set; }

        public string LastName { get; set; }                
       
        #endregion        
    }
    #endregion
}
